#include "networking.h"
#include "movement.h"
#define GR gracze[(int)nrop]

// ================================================================
// wyslij do gniazdka
// ================================================================
void* socket_send(void* data)
{	
	char typ;
	int cnt = 0;
	size_t buf_size;
	void* pck = NULL;
	pck = malloc(HEADING + MAX_PLAYER_MOVES*sizeof(struct ruch));
	int i, start = 0, movec;
	
	while (!koniec)
	{
		// zazadano startu gry
		if ((i_am_host) && (start_issued))
		{
			start_issued = 0;
			typ = PACKET_START_ISSUED;
			if (!wyslij(&timestamp, sizeof(int))) koniec = 1;			
			if (!wyslij(&typ, sizeof(char))) koniec = 1;
			if (!wyslij(&ja, sizeof(char))) koniec = 1;
		}
		
		// zazadano zatrzymania gry
		else if ((i_am_host) && (stop_issued))
		{
			stop_issued = 0;
			typ = PACKET_STOP_ISSUED;
			if (!wyslij(&timestamp, sizeof(int))) koniec = 1;			
			if (!wyslij(&typ, sizeof(char))) koniec = 1;
			if (!wyslij(&ja, sizeof(char))) koniec = 1;
		}
		
		// zlapano golebia
		else if (!glag && pigeon_issued)
		{
			beep();
			pigeon_issued = 0;
			typ = PACKET_PIGEON_ISSUED;
			if (!wyslij(&timestamp, sizeof(int))) koniec = 1;			
			if (!wyslij(&typ, sizeof(char))) koniec = 1;
			if (!wyslij(&ja, sizeof(char))) koniec = 1;
			if (!wyslij(&zlapany, sizeof(struct ruch))) koniec = 1;
		}
		
		// wysylanie pakietow z ruchami
		else
		{
			cnt++;
			if (cnt % 10 == 0) 
			{
				cnt = 0;
				
				pthread_mutex_lock(&mruch);
				movec = ile_ruchow;
				if (ile_ruchow > 0)
				{
					// przepisz n elementow od k-tej pozycji (buf cykl.)
					start = akt_poz;
					for (i=0; i<ile_ruchow; i++)
					{
						memcpy(pck + HEADING + i*sizeof(struct ruch), &(buf_ruch[start]), sizeof(struct ruch));
						start++;
						start %= MAX_PLAYER_MOVES;
					}
					
					buf_size = HEADING + movec*sizeof(struct ruch);
					
					// oproznij bufor
					ile_ruchow = 0;
				}
				else
				{
					buf_size = 0;
				}
				pthread_mutex_unlock(&mruch);
				
				// wyslij pakiet z aktualnym timestampem
				// (jako caly bufor, zeby bylo szybciej)
				if (buf_size)
				{
					*((int*)pck) = timestamp;
					*((char*)(pck+sizeof(int))) = PACKET_PLAYER_MOVES;
					*((char*)(pck+sizeof(int)+sizeof(char))) = ja;
					*((char*)(pck+sizeof(int)+sizeof(char)+sizeof(char))) = (char) movec;
					
					if (!wyslij(pck, buf_size)) koniec = 1;			
				}
			}
		}
		
		start_issued = 0;
		stop_issued = 0;
		pigeon_issued= 0;
		
		usleep(50000);
	}
	
	// w przypadku bledu zamknij socket
	shutdown(sock, SHUT_RDWR);
	free(pck);
	return NULL;
}

// ================================================================
// odbierz z gniazdka
// ================================================================
void* socket_recv(void* data)
{	
	int czas, z;
	int offset;
	char tpak;
	char nrop;
	char ile_pol;
	char ile_ruch, host;
	short int ile_pkt, ww, kk;
	int tm;

	// bufory
	struct ruch e[MAX_OPP_MOVES];
	struct ruch g[MAX_PIGEON_MOVES];
	
	while (!koniec)
	{
		if (!odbierz(&czas, sizeof(int))) koniec = 1; // odbierz czas
		if (!odbierz(&ile_pol, sizeof(char))) koniec = 1;	// odbierz liczbe pól
		
		// aktualne odchylenie, na razie niepotrzebne chyba
		tm = timestamp-czas;
		
		pthread_mutex_lock(&mtim);
		timestamp = czas;
		pthread_mutex_unlock(&mtim);
		
		// foreach pole
		for (z=0; (z<(int)ile_pol) && (koniec == 0); z++)
		{
			if (!odbierz(&tpak, sizeof(char))) koniec = 1; // odbierz typ pola
			switch(tpak)
			{
			// paczka z ruchami przeciwnika 'nrop'
			case PACKET_OPPONENT_MOVES:
				if (!odbierz(&nrop, sizeof(char))) koniec = 1;
				if (nrop >= MAX_PLAYERS) koniec = 1;
				if (!odbierz(&ile_ruch, sizeof(char))) koniec = 1;
				if (ile_ruch > MAX_OPP_MOVES) ile_ruch = MAX_OPP_MOVES;
				if (!odbierz(&e, ile_ruch * sizeof(struct ruch))) koniec = 1;
				
				// zapisujemy do bufora predykcyjnego
				//if (ile_ruch > 5) ile_ruch = 5;
				if (ile_ruch == 5)
				{
					// TODO: nowe dane na poczatku, czy na koncu bufora ??? 
					memcpy(&(GR.buf_pred), e, 5*sizeof(struct ruch));
					GR.ile_pred = 5;
				}
				else if ((ile_ruch < 5) && (GR.ile_pred < 5))
				{
					// sprawdzamy ile jest wolnego miejsca
					if (5-GR.ile_pred < ile_ruch)
					{
						memcpy(tmp, &(GR.buf_pred[GR.ile_pred-(5-ile_ruch)]), (5-ile_ruch)*sizeof(struct ruch));
						memcpy(GR.buf_pred, tmp, (5-ile_ruch)*sizeof(struct ruch));
						offset = (5-ile_ruch);
					}
					else offset = GR.ile_pred;
					
					memcpy(&(GR.buf_pred[offset]), e, ile_ruch*sizeof(struct ruch));
					GR.ile_pred += ile_ruch;
				}
				else if (ile_ruch < 5)
				{
					// przesun ewentualne wczesniejsze wpisy
					memcpy(tmp, &(GR.buf_pred[(int)ile_ruch]), (5-ile_ruch)*sizeof(struct ruch));
					memcpy(GR.buf_pred, tmp, (5-ile_ruch)*sizeof(struct ruch));
					// wstaw nowe wpisy
					memcpy(&(GR.buf_pred[5-ile_ruch]), e, ile_ruch * sizeof(struct ruch));
					GR.ile_pred = 5;
				}
				else if (ile_ruch > 5)
				{
					// wybierz tylko najnowsze ruchy
					memcpy(GR.buf_pred, &(e[ile_ruch-5]), 5 * sizeof(struct ruch));
					GR.ile_pred = 5;
				}
				
				//pthread_mutex_lock(&mplay);
				predict(nrop);
				//pthread_mutex_unlock(&mplay);

				break;
			
			// paczka z ruchami golebia
			case PACKET_PIGEON_MOVES:
				if (!odbierz(&ile_ruch, sizeof(char))) koniec = 1;	// ile ruchow w pakiecie
				if (!odbierz(g, ile_ruch * sizeof(struct ruch))) koniec = 1;
				
				// ponizsze zakomentowane instrukcje pozwalaja zaobserwowac
				// dane o ruchach golebia odebrane z serwera
				
				/*mvprintw(28, 1, "BP1: %d, %d, %d", g[0].ts, g[0].w, g[0].k);
				mvprintw(29, 1, "BP2: %d, %d, %d", g[1].ts, g[1].w, g[1].k);
				mvprintw(30, 1, "BP3: %d, %d, %d", g[2].ts, g[2].w, g[2].k);
				mvprintw(31, 1, "BP4: %d, %d, %d", g[3].ts, g[3].w, g[3].k);
				mvprintw(32, 1, "BP5: %d, %d, %d", g[4].ts, g[4].w, g[4].k);
				mvprintw(33, 1, "BP1: %d, %d, %d", g[5].ts, g[5].w, g[5].k);
				mvprintw(34, 1, "BP2: %d, %d, %d", g[6].ts, g[6].w, g[6].k);
				mvprintw(35, 1, "BP3: %d, %d, %d", g[7].ts, g[7].w, g[7].k);
				mvprintw(36, 1, "BP4: %d, %d, %d", g[8].ts, g[8].w, g[8].k);
				mvprintw(37, 1, "BP5: %d, %d, %d", g[9].ts, g[9].w, g[9].k);
				mvprintw(28, 30, "BP1: %d, %d, %d", g[10].ts, g[10].w, g[10].k);
				mvprintw(29, 30, "BP2: %d, %d, %d", g[11].ts, g[11].w, g[11].k);
				mvprintw(30, 30, "BP3: %d, %d, %d", g[12].ts, g[12].w, g[12].k);
				mvprintw(31, 30, "BP4: %d, %d, %d", g[13].ts, g[13].w, g[13].k);
				mvprintw(32, 30, "BP5: %d, %d, %d", g[14].ts, g[14].w, g[14].k);
				mvprintw(33, 30, "BP1: %d, %d, %d", g[15].ts, g[15].w, g[15].k);
				mvprintw(34, 30, "BP2: %d, %d, %d", g[16].ts, g[16].w, g[16].k);
				mvprintw(35, 30, "BP3: %d, %d, %d", g[17].ts, g[17].w, g[17].k);
				mvprintw(36, 30, "BP4: %d, %d, %d", g[18].ts, g[18].w, g[18].k);
				mvprintw(37, 30, "BP5: %d, %d, %d", g[19].ts, g[19].w, g[19].k);
				refresh();
				*/
				memcpy(buf_golab, g, ile_ruch * sizeof(struct ruch));
				pigeon_moves_count = ile_ruch;
				
				break;
				
			// paczka ze zmiana liczby punktow	
			case PACKET_POINT:
				if (!odbierz(&nrop, sizeof(char))) koniec = 1;	// czyje punkty
				if (nrop >= MAX_PLAYERS) koniec = 1;
				if (!odbierz(&ile_pkt, sizeof(short int))) koniec = 1;	// ile punktow
				GR.points = ile_pkt;
				break;
					
			// paczka z plansza
			case PACKET_MAP:
				loading = 1;
				if (!odbierz(&wiersze, sizeof(int))) koniec = 1;	// ile wierszy
				if (!odbierz(&kolumny, sizeof(int))) koniec = 1;	// ile kolumn
				//sleep(1);
				if (!odbierz(buf, MAX_LEVEL_HEIGHT*MAX_LEVEL_WIDTH)) koniec = 1;	// odbiór levelu
				sleep(1);
				loading = 0;
				break;
			
			// przestaw gracza do pozycji (w, k)
			case PACKET_PLAYER_POSITION:
				if (!odbierz(&nrop, sizeof(char))) koniec = 1;	// numer przeciwnika
				if (nrop >= MAX_PLAYERS) koniec = 1;
				if (!odbierz(&ww, sizeof(short int))) koniec = 1;	// wiersz
				if (!odbierz(&kk, sizeof(short int))) koniec = 1;	// kolumna
				
				if (nrop == ja)
				{
					player_pos.w = ww;
					player_pos.k = kk;
				}
				else
				{
					GR.last_position.w = ww;
					GR.last_position.k = kk;
				}
				break;
			
			// przestaw golebia do pozycji (w, k)
			case PACKET_PIGEON_POSITION:
				if (!odbierz(&ww, sizeof(short int))) koniec = 1;	// wiersz
				if (!odbierz(&kk, sizeof(short int))) koniec = 1;	// kolumna
				
				last_pigeon_position.w = ww;
				last_pigeon_position.k = kk;
				
				break;
			
			// rozpocznij gre
			case PACKET_START_GAME:
				started = 1;
				endgame = 0;
				pthread_mutex_lock(&mtim);
				timestamp = czas;
				pthread_mutex_unlock(&mtim);
				beep();
				break;	
				
			// zakoncz gre	
			case PACKET_STOP_GAME:
				started = 0;
				endgame = 1;
				break;
				
			// przylaczyl sie nowy gracz	
			case PACKET_PLAYER_CONNECTED:
				if (!odbierz(&nrop, sizeof(char))) koniec = 1;
				if (nrop >= MAX_PLAYERS) koniec = 1;
				
				GR.active = 1;
				GR.points = 0;
				GR.buf_count = 0;
				GR.ile_pred = 0;
				GR.last_position.w = 0;
				GR.last_position.k = 0;
				break;
				
			// gracz sie odlaczyl	
			case PACKET_PLAYER_DISCONNECTED:
				if (!odbierz(&nrop, sizeof(char))) koniec = 1;
				if (nrop >= MAX_PLAYERS) koniec = 1;
				beep();
				GR.active = 0;
				// TODO sprzatanko!
				break;	
				
			// serwer przesyla numer i uprawnienia tego klienta	
			case PACKET_MY_NUMBER:
				if (!odbierz(&ja, sizeof(char))) koniec = 1;
				if (!odbierz(&host, sizeof(char))) koniec = 1;
				
				if (host == 1) i_am_host = 1;
				else i_am_host = 0;
				break;	
			
			// serwer odrzuca polaczenie bo jest za duzo graczy
			case PACKET_PLAYER_REFUSED:
				if (!odbierz(&ja, sizeof(char))) koniec = 1;
				if (!odbierz(&host, sizeof(char))) koniec = 1;
				
				servfull = 1;
				koniec = 1;
				
				break;	
			}
		}
	}
	
	shutdown(sock, SHUT_RDWR);
	return NULL;
}

// ================================================================
// funkcja odbierajaca zawsze 'size' bajtow
// ================================================================
int odbierz(void* bf, int size)
{
	if (koniec) return 0;
	int ileb = 0;
	int cum = 0;
	
	while (cum < size)
	{
		ileb = read(sock, bf+cum, size);
		if (ileb <= 0)
		{
			if (!koniec) servdisc=1;
			//beep();
			return 0;
		}
		cum += ileb;
	}
	
	return 1;
}

// ================================================================
// funkcja wysylajaca zawsze 'size' bajtow
// ================================================================
int wyslij(void* bf, int size)
{
	int ileb = 0;
	int cum = 0;
	while (cum < size)
	{
		ileb = write(sock, bf+cum, size);
		if (ileb <= 0)
		{
			if (!koniec) servdisc=1;
			//beep();
			return 0;
		}
		cum += ileb;
	}
	
	return 1;
}
