#ifndef _defs_h
#define _defs_h

#define PORT 51984

#define INTERVAL 30
#define MAX_LEVEL_WIDTH 200
#define MAX_LEVEL_HEIGHT 100
#define MAX_PIGEON_MOVES 20
#define MAX_INT 2147483647
#define MOVES_TO_REMEMBER 30
#define PLAYERS_MAX 32

#define PACKET_PLAYER_MOVES 0
#define PACKET_OPPONENT_MOVES 1
#define PACKET_PIGEON_MOVES 2
#define PACKET_POINT 3
#define PACKET_MAP 5
#define PACKET_PLAYER_POSITION 6
#define PACKET_START_GAME 8
#define PACKET_STOP_GAME 9
#define PACKET_PLAYER_CONNECTED 10
#define PACKET_PLAYER_DISCONNECTED 11
#define PACKET_MY_NUMBER 12
#define PACKET_START_ISSUED 13
#define PACKET_STOP_ISSUED 14
#define PACKET_PIGEON_ISSUED 15
#define PACKET_PLAYER_REFUSED 16

typedef struct position
{
	int timestamp;
	short int y, x;
};

#endif
